#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2two4search.py">
#<abstract4xi abstract = "shoots to direction two"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2two4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2two4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2two4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4two

global count2ack4two
global count2nack4two
global count2found4two
global count2short4two

global current2series4two
global candidate2series4two

global fileobject4two  

global keys2profile4two
global key2profile4two

global left2find4two

global maxsize2ack4two    
global maxsize2file4two 
global max2short4two
global meansize2ack4two
global minsize2ack4two

global two2analyse4search

global profile2fetch4two

global right2find4two

global sumsize2ack4two    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4two = VersionKB4Xi['base2shoot4two']             # base internet address, None=local url

count2ack4two   = 0
count2nack4two  = 0
count2found4two = 0
count2short4two = 0

left2find4two = '('

max2short4two = VersionKB4Xi['max2short4two']
maxsize2file4two = VersionKB4Xi['maxsize2file4two']
maxsize2ack4two  = 0
meansize2ack4two = 0
minsize2ack4two  = 0

current2series4two = "current2series4two5dummy"
candidate2series4two  = "candidate2series4two5dummy"


two2analyse4search  = VersionKB4Xi['two2analyse4search']

profile2fetch4two = {}
profile2fetch4two [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4two [2] = '.jpg'
keys2profile4two = profile2fetch4two.keys()

right2find4two = ')'

sumsize2ack4two  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4two" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4two(target2explore4two):
    global count2ack4two
    global count2nack4two
    global count2found4two
    global count2short4two
    
    global fileobject4two 
       
    global keys2profile4two
    global key2profile4two
    
    global left2find4two

    global max2short4two    
    global maxsize2file4two     
    global maxsize2ack4two    
    global meansize2ack4two
    global minsize2ack4two
  
    global candidate2series4two
    global current2series4two
    
    
    global profile2fetch4two                         # extension for files
    
    global right2find4two
    
    global sumsize2ack4two    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4two = count2found4two + 1
    ack2debug4two = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4two)
    
    ack2profile = False
    for key2profile4two in keys2profile4two:
        if name2target[1] == profile2fetch4two[key2profile4two]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2TWO4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4two
        if ack2debug4two is True:
            print("(STEP 0A/33) OF SHOOT2TWO4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2TWO4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4two:
            count2nack4two = count2nack4two + 1
        else:
            count2ack4two = count2ack4two + 1
            sumsize2ack4two = sumsize2ack4two + size2file
            if size2file > maxsize2ack4two:
                maxsize2ack4two = size2file
            if ((size2file < minsize2ack4two) or (minsize2ack4two == 0)):
                print("(STEP 0B/33) OF SHOOT2TWO4SEARCH - USING MINSIZE2ACK4TWO: ", minsize2ack4two, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4TWO:  0  SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2two//d\twofly29july2012\twofly29july2012 (1).JPG 
                # USING MINSIZE2ACK4TWO:  3866624  SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2two//d\twofly29july2012\twofly29july2012 (2).JPG
                minsize2ack4two = size2file
                print("(STEP 0C/33) OF SHOOT2TWO4SEARCH - SET MINSIZE2ACK4TWO TO: ", minsize2ack4two, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4TWO TO:  3866624  = SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2two//d\twofly29july2012\twofly29july2012 (1).JPG
                # SET MINSIZE2ACK4TWO TO:  3538944  = SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2two//d\twofly29july2012\twofly29july2012 (2).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4two = target2explore4two
            if ack2debug4two is True:print("(STEP 1A/33) OF SHOOT2TWO4SEARCH - URL2WEB4TWO: ", url2web4two) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4two,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4two = url2web4two[0:index2edit] + string2use + url2web4two[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4two)
            shortname2web4two = name2web[0]
            if ack2debug4two is True:
                print("(STEP 1B/33) OF SHOOT2TWO4SEARCH - SHORTNAME2WEB4TWO: ", shortname2web4two)
                # 
            
            string2find4two = '/'
            ackall2found4two = False           
            while 1:
                if ackall2found4two is True:
                    break
                else:
                    index2find4two=str.find(shortname2web4two,string2find4two)   
                    if index2find4two == -1:
                        ackall2found4two = True
                    else:
                        shortname2web4two = shortname2web4two[index2find4two+1:]
                        
            if ack2debug4two is True:            
                print("(STEP 1C/33) OF SHOOT2TWO4SEARCH - SHORTNAME2WEB4TWO: ", shortname2web4two)
                # 
                
            ackall2found4two = False 
            while 1:
                if ackall2found4two is True:
                    break
                else:
                    index2left4two=str.find(shortname2web4two,left2find4two)
                    if index2left4two == -1:
                        current2series4two = shortname2web4two
                        if ack2debug4two is True:
                            print("(STEP 2A/33) OF SHOOT2TWO4SEARCH - CURRENT2SERIES4TWO: ", current2series4two) 
                            # 
                        ackall2found4two = True
                         
                    else:
                        index2right4two=str.find(shortname2web4two,right2find4two)
                        if index2right4two == -1:
                            ackall2found4two = True 
                        else:
                            candidate2series4two = shortname2web4two[0:index2left4two]
                            
                            index3find4two=str.find(shortname2web4two,current2series4two)
                            if index3find4two == -1:
                                
                                current2series4two = candidate2series4two
                                if ack2debug4two is True:
                                    print("(STEP 2B/33) OF SHOOT2TWO4SEARCH - CURRENT2SERIES4TWO: ", current2series4two) 
                                    # 
                                
                                count2short4two = 0
                                fileobject4two.write('<br />' + '\n')
                            else:
                                shortname2web4two = shortname2web4two[index2left4two:index2right4two+1]
                                if ack2debug4two is True:
                                    print("(STEP 2C/33) OF SHOOT2TWO4SEARCH - SHORTNAME2WEB4TWO: ", shortname2web4two)
                                    # 
                                
                                count2short4two = count2short4two + 1
                                if count2short4two >= max2short4two:
                                    count2short4two = 0
                                else:
                                    pass       
                            ackall2found4two = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4two is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4two.write('<br /><b>&raquo;</b><a href="' + url2web4two + '" target="_blank">' + shortname2web4two + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4two = two2analyse4search
                if ack2debug4two is True:
                    print("(STEP 3A/33) OF SHOOT2TWO4SEARCH - BASE2LOCAL4TWO: ", base2local4two)
                    #              
                ack2localtries4two = False                   
                while 1:
                    if ack2localtries4two is True:
                        break
                    else:
                        index2find4two=str.find(url2web4two,base2local4two)            
                        # 
                        #  
                        if index2find4two == -1:
                            ack2localtries4two = True
                        else:
                            if ack2debug4two is True:
                                print("(STEP 3B/33) OF SHOOT2TWO4SEARCH - BASE2BUILD4TWO: ", base2build4two)
                                # 
                            url2web4two = base2build4two + url2web4two[len(base2local4two):]
                            if ack2debug4two is True:
                                print("(STEP 3C/33) OF SHOOT2TWO4SEARCH - URL2WEB4TWO: ", url2web4two)
                                # 
                            
                            if count2short4two < 1: 
                                fileobject4two.write('<br /><b>&raquo;</b><a href="' + url2web4two + '" target="_blank">' + shortname2web4two + '</a>' + '\n')
                            else:
                                fileobject4two.write('<b>&raquo;</b><a href="' + url2web4two + '" target="_blank">' + shortname2web4two + '</a>\n')                            
                            ack2localtries4two = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2TWO4SEARCH FAILED, FILEOBJECT4TWO-WRITE-FAILED: ", str(fileobject4two), time4xi())
      
    else:
        
        count2nack4two = count2nack4two + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2two4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2two4search(queue2two = None, consumer_channel2two = None, publisher_channel2two = None, path2two = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4two
    global count2nack4two
    global count2found4two
    
    global fileobject4two    
    
    global maxsize2ack4two    
    global meansize2ack4two
    global minsize2ack4two
    global sumsize2ack4two    
    
    global maxsize2file4two 
    
    global profile2fetch4two                         # extension for files
    global keys2profile4two
    global key2profile4two

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2TWO4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2TWO4SEARCH -  QUEUE2TWO: ", queue2two)      
    # QUEUE2TWO:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2TWO4SEARCH -  CONSUMER_CHANNEL2TWO: ", consumer_channel2two)
    # CONSUMER_CHANNEL2TWO:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2TWO4SEARCH -  PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)          
    # PUBLISHER_CHANNEL2TWO:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2two is None) or (consumer_channel2two is None) or (publisher_channel2two is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2TWO4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2TWO4SEARCH - QUEUE2TWO: ", queue2two)
        print("(STEP 1C/33) OF SHOOT2TWO4SEARCH - CONSUMER_CHANNEL2TWO: ", consumer_channel2two) 
        print("(STEP 1D/33) OF SHOOT2TWO4SEARCH - PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)
        print("(STEP 1E/33) OF SHOOT2TWO4SEARCH - PATH2TWO: ", path2two)     
        
        return
 
    if (not (queue2two is None) and not(consumer_channel2two is None) and not(publisher_channel2two is None) and (path2two is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2TWO4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2TWO4SEARCH - QUEUE2TWO: ", queue2two)
        print("(STEP 2C/33) OF SHOOT2TWO4SEARCH - CONSUMER_CHANNEL2TWO: ", consumer_channel2two) 
        print("(STEP 2D/33) OF SHOOT2TWO4SEARCH - PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)
        print("(STEP 2E/33) OF SHOOT2TWO4SEARCH - PATH2TWO: ", path2two)     
        return           

    if (not (queue2two is None) and not(consumer_channel2two is None) and not(publisher_channel2two is None) and not(path2two is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2TWO4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2TWO4SEARCH - QUEUE2TWO: ", queue2two)
        # QUEUE2TWO:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2TWO4SEARCH - CONSUMER_CHANNEL2TWO: ", consumer_channel2two)
        # CONSUMER_CHANNEL2TWO:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2TWO4SEARCH - PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)
        # PUBLISHER_CHANNEL2TWO:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2TWO4SEARCH - PATH2TWO: ", path2two)
        # PATH2TWO:  F://temp//yophotos//test2two//
       
        print("(STEP 4A/33) OF SHOOT2TWO4SEARCH - STARTING TO WALK PATH2TWO: ", path2two)   
        # STARTING TO WALK PATH2TWO:  F://temp//yophotos//test2two//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4two = None
        try:
            name2index4two = "index2xxxxxxxx4yo.html"
            path2index4two = path2two + name2index4two
            print("(Step 4B/33) OF SHOOT2TWO4SEARCH - SET PATH2INDEX4TWO TO: ", path2index4two)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2TWO4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4TWO: ", path2index4two)          
            #                    
        fileobject4two = None
        try:
            fileobject4two = open(path2index4two,'w')
            print("(Step 4C/33) OF SHOOT2TWO4SEARCH - OPENED OUTPUT: ", fileobject4two)
            # SHOOT2TWO4SEARCH - OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2two//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2TWO4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4two)         
            # 
        try:                
            fileobject4two.write('<html>\n')
            
            fileobject4two.write('<style type="text/css" media="all">\n')
            fileobject4two.write(' @import "http://www.yourtwoxi.org/css/halongbay.css";\n')
            fileobject4two.write('</style> \n')
            fileobject4two.write('<p>\n')
            fileobject4two.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4two.write('<br /><a id="000">yourtwo<b>&Xi;</b> @Content</a>\n')
            fileobject4two.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4two.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2TWO4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4two)         
            #      
        
        
        KB2name4two = {}
        key2name4two = 0
                 
        for file2walk in DirectoryWalker(path2two):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4two [key2name4two] = file2walk
                    print ("KB2NAME4TWO[", key2name4two, "]: ", KB2name4two [key2name4two])
                    # 
                    
                    key2name4two = key2name4two + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2TWO4SEARCH - FAILED UPDATING KB2NAME4TWO WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4two(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4two.write('<br /> \n')
            fileobject4two.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4two.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4two.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4two.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4two.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4two.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4two.write('</p>\n')
            # 
            fileobject4two.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2TWO4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4two)         
            #            
        try:    
            fileobject4two.close()
            print("(Step 4C/33) OF SHOOT2TWO4SEARCH - CLOSED OUTPUT: ", fileobject4two)         
            # SHOOT2TWO4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2two//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2TWO4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4two)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2TWO4SEARCH - STARTING TO ANALYSE KB2NAME4TWO: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4TWO:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4two  = {}
        AlphaKB4two['a'] = {}
        AlphaKB4two['b'] = {}
        AlphaKB4two['c'] = {}
        AlphaKB4two['d'] = {}
        AlphaKB4two['e'] = {}
        AlphaKB4two['f'] = {}
        AlphaKB4two['g'] = {}
        AlphaKB4two['h'] = {}
        AlphaKB4two['i'] = {}
        AlphaKB4two['j'] = {}
        AlphaKB4two['k'] = {}
        AlphaKB4two['l'] = {}
        AlphaKB4two['m'] = {}
        AlphaKB4two['n'] = {}
        AlphaKB4two['o'] = {}
        AlphaKB4two['p'] = {}
        AlphaKB4two['q'] = {}
        AlphaKB4two['r'] = {}
        AlphaKB4two['s'] = {}
        AlphaKB4two['t'] = {}
        AlphaKB4two['u'] = {}
        AlphaKB4two['v'] = {}
        AlphaKB4two['w'] = {}
        AlphaKB4two['x'] = {}
        AlphaKB4two['y'] = {}
        AlphaKB4two['z'] = {} 
        keys2AlphaKB4two = AlphaKB4two.keys()
        key2AlphaKB4two  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4two = len(path2two)
        # 
        
        keys2name4two = KB2name4two.keys()
                
        for key2name4two in sorted(keys2name4two):
            # 
            name2optimize4two = KB2name4two[key2name4two]
            # 
            shortcut2level4two = name2optimize4two[len2cut4two:]
            # 
            len2shortcut4two = len(shortcut2level4two)
            if len2shortcut4two == 1:
                try:
                    # LEVEL TWO CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4two in keys2AlphaKB4two:
                        KB2level1[key2level1] = shortcut2level4two
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2TWO4SEARCH ** WARNING - SHORTCUT2LEVEL4TWO: ", shortcut2level4two, " NOT IN KEYS2ALPHAKB4TWO: ", keys2AlphaKB4two)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2TWO4SEARCH *** FAILED - SHORTCUT2LEVEL4TWO: ", shortcut2level4two)      
            else:
                try:
                    
                    string2search4two = '\\'
                    shortcut2level4two = shortcut2level4two[2:]
                    
                    index2level4two=str.find(shortcut2level4two,string2search4two)
                    if index2level4two == -1:
                         
                        KB2level2[key2level2] = shortcut2level4two
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4two = shortcut2level4two[index2level4two+1:]
                        index2level4two=str.find(shortcut2level4two,string2search4two)
                        if index2level4two == -1:
                            KB2level3[key2level3] = shortcut2level4two
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4two = shortcut2level4two[index2level4two+1:]
                            index2level4two=str.find(shortcut2level4two,string2search4two)
                            if index2level4two == -1:
                                KB2level4[key2level4] = shortcut2level4two
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4two = shortcut2level4two[index2level4two+1:]
                                index2level4two=str.find(shortcut2level4two,string2search4two)
                                if index2level4two == -1:
                                    KB2level5[key2level5] = shortcut2level4two
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4two = shortcut2level4two[index2level4two+1:]
                                    index2level4two=str.find(shortcut2level4two,string2search4two)
                                    if index2level4two == -1:
                                        KB2level6[key2level6] = shortcut2level4two
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4two = shortcut2level4two[index2level4two+1:]
                                        index2level4two=str.find(shortcut2level4two,string2search4two)
                                        if index2level4two == -1:
                                            KB2level7[key2level7] = shortcut2level4two
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4two = shortcut2level4two[index2level4two+1:]
                                            index2level4two=str.find(shortcut2level4two,string2search4two)
                                            if index2level4two == -1:
                                                KB2level8[key2level8] = shortcut2level4two
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2TWO4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4TWO: ", shortcut2level4two)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2TWO4SEARCH *** FAILED - SHORTCUT2LEVEL4TWO: ", shortcut2level4two)   
        
        print ("(Step 6A/33) OF SHOOT2TWO4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2TWO4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2TWO4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2TWO4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2TWO4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # twofly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2TWO4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2TWO4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2TWO4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2TWO4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2TWO4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2TWO4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2TWO4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2TWO4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2TWO4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2TWO4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2TWO4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2TWO4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2TWO4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2TWO4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2TWO4SEARCH - COUNT2ACK4TWO; ", count2ack4two)
            # COUNT2ACK4TWO;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2TWO4SEARCH - COUNT2NACK4TWO; ", count2nack4two)
            # COUNT2NACK4TWO;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2TWO4SEARCH - COUNT2FOUND4TWO: ", count2found4two)
            # COUNT2FOUND4TWO:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2TWO4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2TWO4SEARCH - FOUND MAX SIZE: ", maxsize2ack4two)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2TWO4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4two)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2TWO4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4two == 0:
                meansize2ack4two = 0
                print ("(Step 7G1/33) OF SHOOT2TWO4SEARCH - MEAN SIZE SET: ", meansize2ack4two)
                #  
            else:       
                meansize2ack4two = int(sumsize2ack4two / count2ack4two)
                print ("(Step 7G2/33) OF SHOOT2TWO4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4two, ", WHERE SUMSIZE2ACK4TWO: ", sumsize2ack4two, " COUNT2ACK4TWO: ", count2ack4two)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4TWO:  10944512  COUNT2ACK4TWO:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2TWO4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4two < maxsize2file4two:
                print ("(Step 7H/33) OF SHOOT2TWO4SEARCH - MIN SIZE MET: ", minsize2ack4two)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2TWO4SEARCH ** MIN DEFINED: ", minsize2ack4two, " EQUALS TO MAXSIZE2FILE4TWO: ", maxsize2file4two)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2TWO4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2TWO4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2TWO4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2TWO4SEARCH - QUEUE2TWO: ", queue2two)
        print("(STEP 7Z3/33) OF SHOOT2TWO4SEARCH - CONSUMER_CHANNEL2TWO: ", consumer_channel2two) 
        print("(STEP 7Z4/33) OF SHOOT2TWO4SEARCH - PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)
        print("(STEP 7Z5/33) OF SHOOT2TWO4SEARCH - PATH2TWO: ", path2two)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.twoxi.com; www.yourtwoxi.com; www.yourtwoxi.org; www.two2xi.com/; www.two4xi.com/; www.two8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2two4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
